package geo.profile;

import geo.profile.data.PerfilSQLiteHelper;
import android.content.Context;


public class Perfil {

	private Integer id;
	private String nombre;
	private int por_hora;
	private String hora_inicio;
	private String hora_fin;
	private String dias_repeticion_horas;
	private int por_gps;
	private double radio;
	private double longitud;
	private double latitud;
	private String dias_repeticion_gps;
	private int	wifi;
	private int tres_g;
	private int bluetooth;
	private int modo_avion;
	private int vibrador;
	private int volumen;
	private int contestador;
	private int desvio_siempre;
	private String telefono_siempre;
	private int desvio_ocupada;
	private String telefono_ocupada;
	private int desvio_sin_respuesta;
	private String telefono_sin_respuesta;
	private String retraso;
	private int desvio_sin_conexion;
	private String telefono_sin_conexion;
	private int gtalk;
	private int whatsapp;
	private int facebook_msn;

	public Perfil() {}
	
	public Perfil(Integer id, String nombre, int por_hora, String hora_inicio,
			String hora_fin, String dias_repeticion_horas, int por_gps, double radio,
			double longitud, double latitud, String dias_repeticion_gps,
			int wifi, int tres_g, int bluetooth, int modo_avion, int vibrador,
			int volumen, int contestador,
			int desvio_siempre, String telefono_siempre, int desvio_ocupada,
			String telefono_ocupada, int desvio_sin_respuesta,
			String telefono_sin_respuesta, String retraso,
			int desvio_sin_conexion, String telefono_sin_conexion, int gtalk,
			int whatsapp, int facebook_msn) {
		super();
		this.id = id;
		this.nombre = nombre;
		this.por_hora = por_hora;
		this.hora_inicio = hora_inicio;
		this.hora_fin = hora_fin;
		this.dias_repeticion_horas = dias_repeticion_horas;
		this.por_gps = por_gps;
		this.radio = radio;
		this.longitud = longitud;
		this.latitud = latitud;
		this.dias_repeticion_gps = dias_repeticion_gps;
		this.wifi = wifi;
		this.tres_g = tres_g;
		this.bluetooth = bluetooth;
		this.modo_avion = modo_avion;
		this.vibrador = vibrador;
		this.volumen = volumen;
		this.contestador = contestador;
		this.desvio_siempre = desvio_siempre;
		this.telefono_siempre = telefono_siempre;
		this.desvio_ocupada = desvio_ocupada;
		this.telefono_ocupada = telefono_ocupada;
		this.desvio_sin_respuesta = desvio_sin_respuesta;
		this.telefono_sin_respuesta = telefono_sin_respuesta;
		this.retraso = retraso;
		this.desvio_sin_conexion = desvio_sin_conexion;
		this.telefono_sin_conexion = telefono_sin_conexion;
		this.gtalk = gtalk;
		this.whatsapp = whatsapp;
		this.facebook_msn = facebook_msn;
	}
	
	public Perfil(String nombre) {
		super();
		this.nombre = nombre;
	}
	
	public void loadPerfil(Context c, int id) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPErfil", null, 1);
		String res[] = bd.getPerfil(id);
		
		this.id = id;
		this.nombre = res[0];
		if(res[1] != null){
			this.por_hora = Integer.parseInt(res[1]);
		}
		this.hora_inicio = res[2];
		this.hora_fin = res[3];
		this.dias_repeticion_horas = res[4];
		if(res[5] != null){
			this.por_gps = Integer.parseInt(res[5]);
		}
		if(res[6] != null){
			this.radio = Double.parseDouble(res[6]);
		}
		if(res[7] != null){
			this.longitud = Double.parseDouble(res[7]);
		}
		if(res[8] != null){
			this.latitud = Double.parseDouble(res[8]);
		}
		this.dias_repeticion_gps = res[9];
		if(res[10] != null){
			this.wifi = Integer.parseInt(res[10]);
		}
		if(res[11] != null){
			this.tres_g = Integer.parseInt(res[11]);
		}
		if(res[12] != null){
			this.bluetooth = Integer.parseInt(res[12]);
		}
		if(res[13] != null){
			this.modo_avion = Integer.parseInt(res[13]);
		}
		if(res[14] != null){
			this.vibrador = Integer.parseInt(res[14]);
		}
		if(res[15] != null){
			this.volumen = Integer.parseInt(res[15]);
		}
		if(res[16] != null){
			this.contestador = Integer.parseInt(res[16]);
		}
		if(res[17] != null){
			this.desvio_siempre = Integer.parseInt(res[17]);
		}
		this.telefono_siempre = res[18];
		if(res[19] != null){
			this.desvio_ocupada = Integer.parseInt(res[19]);
		}
		this.telefono_ocupada =  res[20];
		if(res[21] != null){
			this.desvio_sin_respuesta = Integer.parseInt(res[21]);
		}
		this.telefono_sin_respuesta = res[22];
		this.retraso = res[23];
		if(res[24] != null){
			this.desvio_sin_conexion = Integer.parseInt(res[24]);
		}
		this.telefono_sin_conexion = res[25];
		if(res[26] != null){
			this.gtalk = Integer.parseInt(res[26]);
		}
		if(res[27] != null){
			this.whatsapp = Integer.parseInt(res[27]);
		}
		if(res[28] != null){
			this.facebook_msn = Integer.parseInt(res[28]);
		}
		
		bd.close();
	}

	public Integer savePerfil(Context c) {
		Integer res;
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		res = bd.savePerfil(this);
		bd.close();
		
		return res;
	}
	
	public void deletePerfil(Context c, Integer idPerfil) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.deletePerfil(this,idPerfil);
		bd.close();
	}
	
	public void updatePerfil(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfil(this);
		bd.close();
	}
	
	public void updatePerfilPorHora(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilPorHora(this);
		bd.close();
	}
	
	public String[] buscarPorHora(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarPorHora(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilRepetir(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilRepetir(this);
		bd.close();
	}
	
	public String[] buscarRepetir(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarRepetir(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilPorLocalizacion(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilPorLocalizacion(this);
		bd.close();
	}
	
	public Double[] buscarPorLocalizacion(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		Double [] res = bd.buscarPorLocalizacion(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilSonido(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilSonido(this);
		bd.close();
	}
	
	public String[] buscarSonido(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarSonido(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilConexionesInalambricas(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilConexionesInalambricas(this);
		bd.close();
	}
	
	public String[] buscarConexionesInalambricas(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarConexionesInalambricas(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilModoAvion(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilModoAvion(this);
		bd.close();
	}
	
	public String[] buscarModoAvion(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarModoAvion(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilContestador(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilContestador(this);
		bd.close();
	}
	
	public String[] buscarContestador(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarContestador(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilDesvioSiempre(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilDesvioSiempre(this);
		bd.close();
	}
	
	public void updatePerfilDesvioOcupada(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilDesvioOcupada(this);
		bd.close();
	}
	
	public void updatePerfilDesvioSinRespuesta(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilDesvioSinRespuesta(this);
		bd.close();
	}
	
	public void updatePerfilDesvioSinConexion(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilDesvioSinConexion(this);
		bd.close();
	}
	
	public String[] buscarDesvio(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarDesvio(this);
		bd.close();
		return res;
	}
	
	public void updatePerfilMensajeriaInstantanea(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		bd.updatePerfilMensajeriaInstantanea(this);
		bd.close();
	}
	
	public String[] buscarMensajeriaInstatanea(Context c) {
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		String [] res = bd.buscarMensajeriaInstatanea(this);
		bd.close();
		return res;
	}
	
	public Perfil[] getAllPerfiles(Context c) {
		Perfil[] res;
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		res = bd.getAllPerfiles();
		bd.close();
		return res;
	}
	
	public boolean getNombreRepetido(Context c, String nombreRepetido) {
		boolean res;
		PerfilSQLiteHelper bd = new PerfilSQLiteHelper(c, "DBPerfil", null, 1);
		res = bd.getNombreRepetido(nombreRepetido);
		bd.close();
		return res;
	}
	
	public Integer getId() {
		return id;
	}
	public void setId(Integer id) {
		this.id = id;
	}
	public int getWifi() {
		return wifi;
	}
	public void setWifi(int wifi) {
		this.wifi = wifi;
	}
	public int getBluetooth() {
		return bluetooth;
	}
	public void setBluetooth(int bluetooth) {
		this.bluetooth = bluetooth;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public int getPorHora() {
		return por_hora;
	}

	public void setPorHora(int por_hora) {
		this.por_hora = por_hora;
	}

	public String getHoraInicio() {
		return hora_inicio;
	}

	public void setHoraInicio(String hora_inicio) {
		this.hora_inicio = hora_inicio;
	}

	public String getHoraFin() {
		return hora_fin;
	}

	public void setHoraFin(String hora_fin) {
		this.hora_fin = hora_fin;
	}

	public String getDiasRepeticionHoras() {
		return dias_repeticion_horas;
	}

	public void setDiasRepeticionHoras(String dias_repeticion_horas) {
		this.dias_repeticion_horas = dias_repeticion_horas;
	}

	public int getPorGps() {
		return por_gps;
	}

	public void setPorGps(int por_gps) {
		this.por_gps = por_gps;
	}
	
	public double getRadio() {
		return radio;
	}

	public void setRadio(double radio) {
		this.radio = radio;
	}

	public double getLongitud() {
		return longitud;
	}

	public void setLongitud(double longitud) {
		this.longitud = longitud;
	}

	public double getLatitud() {
		return latitud;
	}

	public void setLatitud(double latitud) {
		this.latitud = latitud;
	}

	public String getDiasRepeticionGps() {
		return dias_repeticion_gps;
	}

	public void setDiasRepeticionGps(String dias_repeticion_gps) {
		this.dias_repeticion_gps = dias_repeticion_gps;
	}

	public int getTresG() {
		return tres_g;
	}

	public void setTresG(int tres_g) {
		this.tres_g = tres_g;
	}

	public int getModoAvion() {
		return modo_avion;
	}

	public void setModoAvion(int modo_avion) {
		this.modo_avion = modo_avion;
	}

	public int getVibrador() {
		return vibrador;
	}

	public void setVibrador(int vibrador) {
		this.vibrador = vibrador;
	}

	public int getVolumen() {
		return volumen;
	}

	public void setVolumen(int volumen) {
		this.volumen = volumen;
	}

	public int getContestador() {
		return contestador;
	}

	public void setContestador(int contestador) {
		this.contestador = contestador;
	}

	public int getDesvioSiempre() {
		return desvio_siempre;
	}

	public void setDesvioSiempre(int desvio_siempre) {
		this.desvio_siempre = desvio_siempre;
	}

	public String getTelefonoSiempre() {
		return telefono_siempre;
	}

	public void setTelefonoSiempre(String telefono_siempre) {
		this.telefono_siempre = telefono_siempre;
	}

	public int getDesvioOcupada() {
		return desvio_ocupada;
	}

	public void setDesvioOcupada(int desvio_ocupada) {
		this.desvio_ocupada = desvio_ocupada;
	}

	public String getTelefonoOcupada() {
		return telefono_ocupada;
	}

	public void setTelefonoOcupada(String telefono_ocupada) {
		this.telefono_ocupada = telefono_ocupada;
	}

	public int getDesvioSinRespuesta() {
		return desvio_sin_respuesta;
	}

	public void setDesvioSinRespuesta(int desvio_sin_respuesta) {
		this.desvio_sin_respuesta = desvio_sin_respuesta;
	}

	public String getTelefonoSinRespuesta() {
		return telefono_sin_respuesta;
	}

	public void setTelefonoSinRespuesta(String telefono_sin_respuesta) {
		this.telefono_sin_respuesta = telefono_sin_respuesta;
	}

	public String getRetraso() {
		return retraso;
	}

	public void setRetraso(String retraso) {
		this.retraso = retraso;
	}

	public int getDesvioSinConexion() {
		return desvio_sin_conexion;
	}

	public void setDesvioSinConexion(int desvio_sin_conexion) {
		this.desvio_sin_conexion = desvio_sin_conexion;
	}

	public String getTelefonoSinConexion() {
		return telefono_sin_conexion;
	}

	public void setTelefonoSinConexion(String telefono_sin_conexion) {
		this.telefono_sin_conexion = telefono_sin_conexion;
	}

	public int getGTalk() {
		return gtalk;
	}

	public void setGTalk(int gtalk) {
		this.gtalk = gtalk;
	}

	public int getWhatsApp() {
		return whatsapp;
	}

	public void setWhatsApp(int whatsapp) {
		this.whatsapp = whatsapp;
	}

	public int getFacebookMSN() {
		return facebook_msn;
	}

	public void setFacebookMSN(int facebook_msn) {
		this.facebook_msn = facebook_msn;
	}
}
