package geo.profile.receiver;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import android.app.NotificationManager;
import android.bluetooth.BluetoothAdapter;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.media.AudioManager;
import android.net.ConnectivityManager;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.provider.Settings;

public class AlarmReceiverInicio extends BroadcastReceiver {
//	@Override
	
	NotificationManager nm;
	
	public void onReceive(Context arg0, Intent arg1) {
		configurarPerfil(arg0, arg1);
	}
	
	public void configurarPerfil(Context context, Intent intent){
		
		BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		
		//Obtenemos los extras del Intent
        Bundle bun = intent.getExtras();
        		
		int vibrador = bun.getInt("vibrador");
		int volumen = bun.getInt("volumen");
		int wifi = bun.getInt("wifi");
		int tres_g = bun.getInt("tres_g");
		int bluetooth =bun.getInt("bluetooth");
		int modo_avion = bun.getInt("modo_avion");
		
		int desvio_siempre = bun.getInt("desvio_siempre");
		String telefono_siempre = bun.getString("telefono_siempre");
		int desvio_ocupada = bun.getInt("desvio_ocupada");
		String telefono_ocupada = bun.getString("telefono_ocupada");
		int desvio_sin_respuesta = bun.getInt("desvio_sin_respuesta");
		String telefono_sin_respuesta = bun.getString("telefono_sin_respuesta");
		String retraso = bun.getString("retraso");
		int desvio_sin_conexion = bun.getInt("desvio_sin_conexion");
		String telefono_sin_conexion = bun.getString("telefono_sin_conexion");
		
		int gtalk = bun.getInt("gtalk");
		int whatsapp = bun.getInt("whatsapp");
		int facebook_msn = bun.getInt("facebook_msn");
		
		//Variables para ver el estado anterior
		
		boolean vibrador_anterior = bun.getBoolean("vibrador_anterior");
		boolean silencio_anterior = bun.getBoolean("silencio_anterior");
//		Integer volumen_anterior = bun.getInt("volumen_anterior");
		boolean wifi_anterior = bun.getBoolean("wifi_anterior");
		boolean tres_g_anterior = bun.getBoolean("tres_g_anterior");
		boolean bluetooth_anterior = bun.getBoolean("bluetooth_anterior");
		boolean modo_avion_anterior = bun.getBoolean("modo_avion_anterior");
		
		//Conocer el estado de los desvos de llamada es un trabajo de investigacin que no se
    	//ha podido completar dada su gran dificultad
		
//		boolean desvio_siempre_anterior;
//		boolean desvio_ocupada_anterior;
//		boolean desvio_sin_respuesta_anterior;
//		boolean desvio_sin_conexion_anterior;
		
		//Conocer el estado de las aplicaciones de mensajera instantnea no es posible
//		boolean gtalk_anterior;
//		boolean whatsapp_anterior;
//		boolean facebook_msn_anterior;
    	
		//Wifi
		if(wifi == 1) {	//Activar Wifi
			if(!wifi_anterior){
				((WifiManager) context.getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(true);
			}
		} else {	//Desactivar Wifi
			if(wifi_anterior){
				((WifiManager) context.getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(false);
			}
		}
		//Tres_G
		Boolean enabled;
		if(tres_g == 1){
			//Activar 3g
			if(!tres_g_anterior){
				enabled = true;
				final ConnectivityManager conman = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
			    Class<?> conmanClass;
				try {
					conmanClass = Class.forName(conman.getClass().getName());
					final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
					iConnectivityManagerField.setAccessible(true);
					final Object iConnectivityManager = iConnectivityManagerField.get(conman);
					final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
					final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
					setMobileDataEnabledMethod.setAccessible(true);
					setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
				} catch (ClassNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchFieldException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}else{
			//Desactivar3g
			if(tres_g_anterior){
				enabled = false;
				final ConnectivityManager conman = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
			    Class<?> conmanClass;
				try {
					conmanClass = Class.forName(conman.getClass().getName());
					final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
					iConnectivityManagerField.setAccessible(true);
					final Object iConnectivityManager = iConnectivityManagerField.get(conman);
					final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
					final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
					setMobileDataEnabledMethod.setAccessible(true);
					setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
				} catch (ClassNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchFieldException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		//Bluetooth
		if(bluetooth == 1) {
			//Activar bluetooth
			if(!bluetooth_anterior){
				if(mBluetoothAdapter != null){
					mBluetoothAdapter.enable();
				}
			}
		} else {
			//Desactivar bluetooth
			if(bluetooth_anterior){
				if(mBluetoothAdapter != null){
					mBluetoothAdapter.disable();
				}
			}
		}
		//Modo avion
		if(modo_avion == 1){
			//Activar Modo Avion
			if(modo_avion_anterior == false){
				Settings.System.putInt(context.getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 1);
				//Broadcast Intent para informar
		        Intent intent_modo_avion = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
		        intent_modo_avion.putExtra("state", modo_avion);
		        context.sendBroadcast(intent_modo_avion);

			}
		}else{
			//Desactivar Modo Avion
			if(modo_avion_anterior == true){
				Settings.System.putInt(context.getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 0);
				//Broadcast Intent para informar
		        Intent intent_modo_avion = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
		        intent_modo_avion.putExtra("state", modo_avion);
		        context.sendBroadcast(intent_modo_avion);

			}
		}
		//Sonido
		//Vibrador y Volumen
		if(vibrador == 0 && volumen == 0) {
			if(!silencio_anterior){
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_SILENT);
			}
		}else if(vibrador == 0 && volumen != 0) {
			((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_NORMAL);
			((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setStreamVolume(AudioManager.STREAM_RING, volumen, AudioManager.FLAG_SHOW_UI);
		} else if(vibrador == 1) {
			if(!vibrador_anterior){
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_VIBRATE);
			}
		}
		//Tono de llamada (no implementado en esta version)
		
		//Contestador (Es lo mismo que desvo de llamadas)
		
		//Desvo de llamadas (En ninguno de los casos se comprueba el estado anterior ya que 
		//es un trabajo de investigacin que no se ha podido completar dada su gran dificultad.
		//Por ello se activan y desactivan independientemente del estado anterior.
		//Comentamos el caso en el que hay que desactivarlo para que no salga constantemente el dilogo informando.
		//Desvio Siempre
		if(desvio_siempre == 1){
			//Activar desvio siempre (si no est activado)
			String numero = telefono_siempre;
			String callForwardString = "**21*"+numero+"#";    
			Intent intentCallForward = new Intent(Intent.ACTION_CALL);  
			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
			intentCallForward.setData(uri2);                                
			context.startActivity(intentCallForward); 
			
		}else{
//			//Desactivar desvio siempre (si est activado)
//			String callForwardString = "##21#";    
//			Intent intentCallForward = new Intent(Intent.ACTION_CALL);   
//			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//			intentCallForward.setData(uri2);                                
//			context.startActivity(intentCallForward); 
			
		}
		//Desvio Ocupada
		if(desvio_ocupada == 1){
			//Activar desvio ocupada (si no est activado)
			String numero = telefono_ocupada;
			String callForwardString = "**67*"+numero+"#";    
			Intent intentCallForward = new Intent(Intent.ACTION_CALL); 
			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
			intentCallForward.setData(uri2);                                
			context.startActivity(intentCallForward); 
		}else{
//			//Desactivar desvio ocupada (si est activado)
//			String callForwardString = "##67#";    
//			Intent intentCallForward = new Intent(Intent.ACTION_CALL);  
//			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//			intentCallForward.setData(uri2);                                
//			context.startActivity(intentCallForward); 
		}
		//Desvio Sin Respuesta
		if(desvio_sin_respuesta == 1){
			//Activar desvio sin respuesta (si no est activado)
			String numero = telefono_sin_respuesta;
			String callForwardString = "**61*"+numero+"**"+retraso+"#";    
			Intent intentCallForward = new Intent(Intent.ACTION_CALL); 
			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
			intentCallForward.setData(uri2);                                
			context.startActivity(intentCallForward); 
		}else{
//			//Desactivar desvio sin respuesta (si est activado)
//			String callForwardString = "##61#";    
//			Intent intentCallForward = new Intent(Intent.ACTION_CALL); 
//			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//			intentCallForward.setData(uri2);                                
//			context.startActivity(intentCallForward); 
		}
		//Desvio Sin Conexion
		if(desvio_sin_conexion == 1){
			//Activar desvio sin conexion (si no est activado)
			String numero = telefono_sin_conexion;
			String callForwardString = "**62*"+numero+"#";    
			Intent intentCallForward = new Intent(Intent.ACTION_CALL); 
			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
			intentCallForward.setData(uri2);                                
			context.startActivity(intentCallForward); 
		}else{
//			//Desactivar desvio sin conexion (si est activado)
//			String callForwardString = "##62#";    
//			Intent intentCallForward = new Intent(Intent.ACTION_CALL);   
//			intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//			Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//			intentCallForward.setData(uri2);                                
//			context.startActivity(intentCallForward); 
		}
		
		//Mensajera instantnea
		//GTalk (No es posible interactuar con la aplicacin)
		if(gtalk == 1){
			//Activar GTalk
		}else{
			//Desactivar GTalk
		}
		//WhatsApp (No es posible interactuar con la aplicacin)
		if(whatsapp == 1){
			//Activar WhatsApp
		}else{
			//Desactivar WhatsApp
		}
		//Facebook MSN (No es posible interactuar con la aplicacin)
		if(facebook_msn == 1){
		}else{
			//Desactivar Facebook MSN
		}
	}
}