package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

public class CrearPerfilIntroducirNombreActivity extends Activity {
	EditText edtNombrePerfil;
	Editable nombre;
	Button btnSiguienteCrearPerfil;
	Button btnAtrasCrearPerfil;
	
	private static final int DIALOGO_ALERTA_NOMBRE = 5;
	private static final int DIALOGO_ALERTA_NOMBRE_REPETIDO = 6;

	Integer idPerfil;
	public  Perfil perfil;
		 
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.crearperfil_introducirnombre);
        
        //Nombre del perfil
        
        edtNombrePerfil = (EditText)findViewById(R.id.EdtNombrePerfil);
       	nombre = edtNombrePerfil.getText();
       	
       	//Boton Siguiente
    	btnSiguienteCrearPerfil = (Button)findViewById(R.id.BtnSiguienteCrearPerfil);
    	
    	btnSiguienteCrearPerfil.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		
        		idPerfil = savePerfil(v);
        		
        		Perfil perfil = new Perfil();
        		perfil.loadPerfil(CrearPerfilIntroducirNombreActivity.this, idPerfil);
        	}
        }); 
        
    	//Boton Atras
    	
    	btnAtrasCrearPerfil = (Button)findViewById(R.id.BtnAtrasCrearPerfil);
    	
  		btnAtrasCrearPerfil.setOnClickListener(new View.OnClickListener() {
    	    public void onClick(View arg0)
    	    {
    	    	cancelPerfil();
    	    }
    	});
	}
    

  //Guardar el nuevo perfil
    public Integer savePerfil(View view) {
    	Integer res = -1;

    	if (edtNombrePerfil.getText().toString().equals("")){
    		showDialog(DIALOGO_ALERTA_NOMBRE);
    	}else{
    		
    		perfil = new Perfil(nombre.toString());
    		
    		boolean existeNombre = perfil.getNombreRepetido(this, nombre.toString());
    		
    		if(existeNombre){
				showDialog(DIALOGO_ALERTA_NOMBRE_REPETIDO);
				if(idPerfil != null){
					res = idPerfil;
				}
    		}else{
    			res = perfil.savePerfil(this);
    			Intent intent = new Intent(CrearPerfilIntroducirNombreActivity.this, CrearPerfilActivity.class);
	    		intent.putExtra("id", res);
	    		intent.putExtra("nombre", nombre.toString());
				startActivity(intent);
    		}
    	}
    	
    	return res;
    }
    
    @Override
	protected Dialog onCreateDialog(int id) {
    	Dialog dialogo = null;

    	switch(id)
    	{
    		case DIALOGO_ALERTA_NOMBRE:
    			dialogo = crearDialogoAlertaNombre();
    			break;
    		case DIALOGO_ALERTA_NOMBRE_REPETIDO:
    			dialogo = crearDialogoAlertaNombreRepetido();
    			break;
    		default:
    			dialogo = null;
    			break;
    	}
    
    	return dialogo;
    }

    
    private Dialog crearDialogoAlertaNombre()
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
     
        builder.setTitle("Error");
        builder.setMessage("Debe introducir un nombre antes de continuar.");
        builder.setPositiveButton("OK", new OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });
     
        return builder.create();
    }
    
    private Dialog crearDialogoAlertaNombreRepetido()
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
     
        builder.setTitle("Error");
        builder.setMessage("Ya existe un perfil con ese nombre. Introduzca un nombre distinto.");
        builder.setPositiveButton("OK", new OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });
     
        return builder.create();
    }
    
    //Actualizar el perfil actual
    public void updatePerfil(View view) {
    	
    	EditText nombrePerfil = (EditText) findViewById(R.id.NombrePerfil);
    	String nombre = nombrePerfil.getText().toString();
    	perfil.setNombre(nombre);
    	
    	perfil.updatePerfil(this);	
    	idPerfil = perfil.getId();
    	finish();
        
    }
    
    //Salir
    public void cancelPerfil(){
    	
    	EditText nombrePerfil = (EditText) findViewById(R.id.NombrePerfil);
    	
    	if(nombrePerfil != null){
    		String nombre = nombrePerfil.getText().toString();
        	perfil.setNombre(nombre);
    		perfil.deletePerfil(this,idPerfil);	
    	}
    	
    	finish();
    }
}