package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;

public class MensajeriaInstantaneaActivity extends Activity {
	
	Integer idPerfil;
	Perfil perfil;
	
	CheckBox chkGTalk;
	CheckBox chkWhatsApp;
	CheckBox chkFacebookMSN;
	Button btnGuardarMensajeriaInstantanea;
	
	String [] mensajeria;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mensajeriainstantanea);
        
        //Obtenemos el id (extra en el intent)
        Bundle bun = this.getIntent().getExtras();
        idPerfil = bun.getInt("id");
        
        //Obtenemos los datos de Mensajeria Instantanea de la BD
        perfil = new Perfil();
    	perfil.loadPerfil(MensajeriaInstantaneaActivity.this,idPerfil);
    	mensajeria = perfil.buscarMensajeriaInstatanea(this);
        
        //Checkbox GTalk
	
        chkGTalk = (CheckBox)findViewById(R.id.ChkGTalk);
        
        //Checkbox WhatsApp
    	
        chkWhatsApp = (CheckBox)findViewById(R.id.ChkWhatsApp);
        		
        //Checkbox FacebookMSN
        		
        chkFacebookMSN = (CheckBox)findViewById(R.id.ChkFacebookMSN);
        
        if(Integer.parseInt(mensajeria[0]) == 1){	//GTalk
        	chkGTalk.setChecked(true);
        }else{
        	chkGTalk.setChecked(false);	//No GTalk
        }
		
		if(Integer.parseInt(mensajeria[1]) == 1){	//WhatsApp
			chkWhatsApp.setChecked(true);
        }else{
        	chkWhatsApp.setChecked(false);	//No WhatsApp
        }
		
		if(Integer.parseInt(mensajeria[2]) == 1){	//FacebookMSN
			chkFacebookMSN.setChecked(true);
        }else{
        	chkFacebookMSN.setChecked(false);	//No FacebookMSN
        }
        
      //Botn Guardar
		
  		btnGuardarMensajeriaInstantanea = (Button)findViewById(R.id.BtnGuardarMensajeriaInstantanea);
  		
  		btnGuardarMensajeriaInstantanea.setOnClickListener(new View.OnClickListener() {
  		    public void onClick(View arg0)
  		    {
  		    	guardarMensajeriaInstantanea(arg0);
  		    }
  		});
    }
    
    public void guardarMensajeriaInstantanea(View v){
    	
    	perfil = new Perfil();
    	perfil.loadPerfil(MensajeriaInstantaneaActivity.this,idPerfil);
    	
    	if(chkGTalk.isChecked()){
    		perfil.setGTalk(1);
    	}else{
    		perfil.setGTalk(0);
    	}
    	
    	if(chkWhatsApp.isChecked()){
    		perfil.setWhatsApp(1);
    	}else{
    		perfil.setWhatsApp(0);
    	}
    	
    	if(chkFacebookMSN.isChecked()){
    		perfil.setFacebookMSN(1);
    	}else{
    		perfil.setFacebookMSN(0);
    	}
    	
    	finish();
    	
    	perfil.updatePerfilMensajeriaInstantanea(this);
    }
}